#include "internal.mh"

void print_coverage_data(void);
int printf(const char *, ...);

int square(int i)
{
	return i * i;
}

int main(int argc, char **argv)
{
	printf("%i arguments\n",argc);
	printf("square = %i\n",square(argc));
	return 0;
}

/* This example does a simple form of coverage analysis
 * by counting each entry to functions defined in this
 * translation-unit.
 */
meta void $main(strg arg[])
{
	func all_func[], *f;
	zed i, num_func;
	symb pd;
	strg fname;

	$get_all_functions(all_func);
	num_func = 0;
	f = all_func;
	pd = $define($module(),typeof(unsigned []),(ident)"coverage_data");
	empty:= {}
	$implement(print_coverage_data,codeof(empty));
	report:= print_coverage_data();
	$add_epilogue(main,codeof(report));
	while (*f) {
		coverage:= ++coverage_data[num_func];
		print:= printf("%s: %u\n",fname,coverage_data[num_func]);

		fname = (strg) *f;
		if (fname == "main") {
			++f;
			continue;
		}
		$add_prologue(*f,codeof(coverage));
		$add_epilogue((func)print_coverage_data,codeof(print));
		++f;
		++num_func;
	}
	$info("num_func = " + (strg) num_func);
	$resize_array(pd,num_func);
}

/* vim:tw=0
 * vim:filetype=c
 */
