#include "internal.mh"

/* this is a test function that will be searched */
int very_bad_hex_to_int(const char *s)
{
	int ret = 0;
	while (*s) {
		ret <<= 4;
		switch (*s) {
		case '0':
			break;
		case '1':
			ret += 1;
			break;
		case '2':
			ret += 2;
			break;
		case '3':
			ret += 3;
			break;
		case '4':
			ret += 4;
			break;
		case '5':
			ret += 5;
			break;
		case '6':
			ret += 6;
			break;
		case '7':
			ret += 7;
			break;
		case '8':
			ret += 8;
			break;
		case '9':
			ret += 9;
			break;
		case 'a':
			ret += 10;
			break;
		case 'b':
			ret += 11;
			break;
		case 'c':
			ret += 12;
			break;
		case 'd':
			ret += 13;
			break;
		case 'e':
			ret += 14;
			break;
		case 'f':
			ret += 15;
			break;
		default:
			return ret;
		}
		++s;
	}
	return ret;
}


/* The $main meta-function, which is the entry to the meta-program,
 * searches for case-statements and print the results.
 */
meta void $main(strg arg[])
{
	/* this is the search pattern */
	pattern := case x: s;

	/* initialize x with null, so that we match any expression with codeof pattern */
	expr x = 0;
	/* initialize s with null, so that we match any statement as
	 * child of the case-statement */
	stmt s = 0;

	/* m will contain the matches
	 * i is a pointer to stmt that will be used as iterator
	 * e is a pointer to stmt that will mark the end of valid
	 *   matches in m
	 */
	stmt m[], *i, *e;


	/* search for the pattern */
	e = $find_stmt(codeof pattern, (stmt)very_bad_hex_to_int, m);

	/* if the result of the call to $find_stmt is equal to the
	 * passed pointer, then no matches were found. 
	 */
	if (m == e) {
		$print("no matches found");
		return;
	}

	/* initialize i for iteration over all found matches */
	i = m;
	while (i != e) {
		/* print the found match */
		$print((strg)*i);
		++i;
	}
}

/* vim:ft=c
 */
