#include "internal.mh"

/*
 * This example shows how you can define a complete function.
 */

meta void $main(strg arg[])
{
	/* the metavariables we will need */
	type t,mt;
	ident d;
	symb m;

	/* the code-structure-pattern definition for our main function */
	main:= {
		t d;
		return 0;
	}

	/* the pattern of additional code we want to add */
	code := d = 0;

	/* we assign d the identifier ret_val */
	d = (ident) "ret_val";

	/* type assignments with the help of the typeof operator */
	t = typeof(int);
	mt = typeof(int (int,char **));

	/* give our user some feedback (enabled with flag -v4 or -v5) */
	$info("implementing main with type " + (strg) mt);

	/* declare the function */
	m = $define($module(),mt,(ident)"main");

	/* now implement the function with the help of the codeof operator */
	$implement(m,codeof main);

	/* finally, we add an additional statement */
	$add_epilogue((func)m, codeof code);
}

/* vim:ft=c
 * vim:tw=0
 */
