#include "internal.mh"

/* The following C functions are just used as test patterns. */

int atoi(const char *);

int square(int a)
{
	if (a)
		return a * a;
	return 0;
}

int pyth(int x, int y)
{
	return square(x) + square(y);
}

int accum(int x)
{
	int j = 0, i;
	for (i = 0; i < x; ++i)
		j += pyth(i,x);
	return j;
}

int main(int argc, char **argv)
{
	int x;
	if (argc > 1)
		x = atoi(argv[1]);
	else
		x = argc;
	x = accum(x);
	return 0;
}


/* This example demonstrate the quick assign method that can
 * be used to assign the results of a find to the metavariables
 * employed in the search.
 */

meta void $main(strg arg[])
{
	expr p = (expr)square(arg0);
	expr s = (expr)(arg0 * arg1);
	expr arg0,arg1, matches[], *m = matches;
	stmt rets[], *r = rets;

	$get_returns(pyth,r);
	while (*r) {
		expr re = $get_return_expr(*r);
		$print("matching: " + (strg) re + "\n");
		$find_expr(p,re,matches);
		m = matches;
		while (*m) {
			$print("matching " + (strg)p + " against " + (strg) *m + "\n");
			arg0 = 0;
			if ($match_expr(p,*m))
				$error("match inconsistency");
			else {
				arg1 = arg0;
				/* be aware that in case arg0 has side effects you should not do this */
				$print("replacing: " + (strg) *m + "\n");
				$replace_expr(*m,s);
			}
			++m;
		}
		++r;
	}
}

/* vim:ft=c
 * vim:tw=0
 */
