/* 
 * This example demonstrates a sequence of different search operations.
 * Finally, an example is given how to replace an expression with another.
 *
 * To run this example, you must call metacc with the option -std=c99.
 */

/* C part - these are only test-patterns without meaning. */

int atoi(const char *);

int square(int a)
{
	if (a)
		return a * a;
	return 0;
}

int pyth(int x, int y)
{
	return square(x) + square(y);
}

int accum(int x)
{
	int j = 0;
	for (int i = 0; i < x; ++i)
		j += pyth(i,x);
	return j;
}

int main(int argc, char **argv)
{
	int x;
	if (argc > 1)
		x = atoi(argv[1]);
	else
		x = argc;
	x = accum(x);
	return 0;
}


#include "internal.mh"

meta void $main(strg arg[])
{
	expr e, e1;
	type t = 0;
	ident n;
	stmt s,m[], *x = m;
	func fs[],*f;
	symb y;

	f = fs;
	$get_all_functions(f);
	$print("searching for if-statements\n");
if_st := if(e) s;
	f = fs;
	x = m;
	t = typeof(char *);
	while(*f) {
		x = $find_stmt(codeof if_st,(stmt)*f,x);
		++f;
	}
	$print("found " + (strg)(x-m) + " if-statements:\n");
	x = m;
	while (*x) {
		$print("    " + (strg)(*x));
		++x;
	}

	$print("searching for for-statements with iterator type char *\n");
for_st := for(t n = 0; e; e1) s;
	f = fs;
	x = m;
	while(*f) {
		x = $find_stmt(codeof for_st,(stmt)*f,x);
		++f;
	}
	$print("found " + (strg)(x-m) + " for-statements:\n");
	x = m;
	while (*x) {
		$print("\t" + (strg)(*x) + "\n");
		++x;
	}

	$print("searching for for-statements with arbitrary iterator type\n");
	f = fs;
	x = m;
	t = 0;
	while(*f) {
		x = $find_stmt(codeof for_st,(stmt)*f,x);
		++f;
	}
	$print("found " + (strg)(x-m) + " for-statements:\n");
	x = m;
	while (*x) {
		$print("    " + (strg)(*x));
		++x;
	}

	$print("searching for return-statements\n");
ret_st := return e;
	while(*f) {
		x = $find_stmt(codeof ret_st,(stmt)*f,x);
		++f;
	}
	$print("found " + (strg)(x-m) + " return-statements:\n");
	x = m;
	while (*x) {
		$print("    " + (strg)(*x));
		++x;
	}

	/* finally we replace the zero in return from main with x */
	x = $find_stmt(codeof ret_st,(stmt)main,m);
	if (x == m)
		$error("could not find return statements with expression in main");
	else {
		x = m;
		while (*x) {
			e1 = $get_return_expr(*x);
			y = $get_symbol((scope)(stmt)main,(ident)"x");
			if (y == 0)
				$error("could not find a variable named x in target scope");
			else
				$replace_expr(e1,(expr)y);
			++x;
		}
	}
}

/* vim:ft=c
 * vim:tw=0
 */
